%define name		spring
%define version		1.2.5
%define release		2jpp
%define	section		free


Name:		%{name}
Summary:	Spring J2EE Framework
Url:		http://www.springframework.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	Apache Software License 2.0
Group:		Development/Libraries/Application Frameworks
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
#Source0:	spring-framework-1.2.5.zip
Source0:	spring-framework-1.2.5-with-dependencies.zip
Patch0:		spring-1.2-JaxRpcSupportTests.patch
Patch1:		spring-1.2-SqlClientMapTests.patch
Patch2:		spring-1.2-LocalSessionFactoryBeanTests.patch
Patch3:		spring-1.2-PathMatchingResourcePatternResolverTests.patch
Patch4:		spring-1.2-RemoteMBeanClientInterceptorTests.patch
Patch5:		spring-1.2-ConnectorServerFactoryBeanTests.patch


BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	ant >= 0:1.6
BuildRequires:	junit 
BuildRequires:	java >= 0:1.4
BuildRequires:	antlr
BuildRequires:	aopalliance
BuildRequires:	asm
BuildRequires:	axis
BuildRequires:	burlap
BuildRequires:	c3p0 >= 0:0.9.0
BuildRequires:	cglib
BuildRequires:	jakarta-commons-attributes
BuildRequires:	jakarta-commons-beanutils
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-dbcp
BuildRequires:	jakarta-commons-digester
BuildRequires:	jakarta-commons-discovery
BuildRequires:	jakarta-commons-fileupload
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	jakarta-commons-lang
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-pool
BuildRequires:	jakarta-commons-validator
BuildRequires:	jakarta-taglibs-standard
BuildRequires:	cos-multipart
BuildRequires:	db-ojb
BuildRequires:	dom4j
BuildRequires:	easymock
BuildRequires:  ehcache
BuildRequires:	ejb
BuildRequires:	freemarker
BuildRequires:	hessian
BuildRequires:	hibernate
BuildRequires:	hibernate3
BuildRequires:	hibernate-annotations
BuildRequires:	hsqldb
BuildRequires:	ibatis
BuildRequires:	ibatis1
BuildRequires:	itext
BuildRequires:	j2ee-connector
BuildRequires:	jaf
BuildRequires:	jamonapi
BuildRequires:	jasperreports >= 0:1.0.0
BuildRequires:	javamail
BuildRequires:	jaxen
BuildRequires:	apache-jdo20
BuildRequires:	jexcelapi
BuildRequires:	jms
BuildRequires:	jmx
BuildRequires:	jmxremote
BuildRequires:	jotm
BuildRequires:	jsf
BuildRequires:	jta
BuildRequires:	jakarta-poi >= 0:2.5.1
BuildRequires:	log4j
BuildRequires:	oro
BuildRequires:	quartz
BuildRequires:	servlet24
BuildRequires:	struts
BuildRequires:	toplink-api
BuildRequires:	velocity
BuildRequires:	velocity-tools
BuildRequires:	xapool
BuildRequires:	xjavadoc

Requires:	java >= 0:1.4

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Spring is a layered Java/J2EE application framework, 
based on code published in Expert One-on-One J2EE 
Design and Development by Rod Johnson (Wrox, 2002). 

%package core
Summary:	Spring core
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	jakarta-commons-logging

%description core
Spring bean container, core utilities
Optionals: log4j

%package aop
Summary:	Spring aop
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}
Requires:	aopalliance

%description aop
Spring AOP framework, source level metadata support
Optionals: cglib, jakarta-commons-attributes

%package beans
Summary:	Spring beans
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}
Requires:	cglib

%description beans
%{summary}.

%package context
Summary:	Spring context
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description context
Spring application context, validation, UI support, mail,
JNDI, JMS, EJB, remoting, scheduling, caching
Optionals: velocity, freemarker, javamail, jms, ejb, axis,
hessian, burlap, quartz, ehcache

%package dao
Summary:	Spring dao
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description dao
Spring DAO support, transaction infrastructure, JDBC support
Optionals: spring-aop, jta

%package hibernate
Summary:	Spring hibernate
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}
Requires:	hibernate

%description hibernate
%{summary}.

%package jdbc
Summary:	Spring jdbc
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}
Requires:	jakarta-commons-dbcp

%description jdbc
%{summary}.

%package orm
Summary:	Spring orm
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-dao = 0:%{version}-%{release}

%description orm
Spring Hibernate support, JDO support, Apache OJB, iBATIS SQL Maps
Optionals: hibernate, hibernate3, hibernate-annotations, 
apache-jdo20, db-ojb, ibatis, j2ee-connector

%package remoting
Summary:	Spring remoting
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description remoting
%{summary}.

%package support
Summary:	Spring support
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description support
%{summary}.

%package web
Summary:	Spring web
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-context = 0:%{version}-%{release}
Requires:	servlet24

%description web
Spring web application support, multipart resolver, struts support,
web utilities
Optionals: jspapi, jakarta-taglibs-standard, jakarta-commons-fileupload,
cos-multipart, struts

%package webmvc
Summary:	Spring webmvc
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-web = 0:%{version}-%{release}

%description webmvc
Spring framework servlets, web MVC framework, web controllers, web views
Optionals: tiles, itext, poi

%package all
Summary:	Spring all except mocks
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	jakarta-commons-logging
Requires:	aopalliance
Requires:	servlet24

%description all
Spring everything except mocks
Optionals: log4j, cglib, jakarta-commons-attributes
velocity, freemarker, javamail, jms, ejb, axis, hessian, 
burlap, quartz, ehcache, jta, hibernate, hibernate3, 
hibernate-annotations, apache-jdo20, ojb, ibatis,
jspapi, jakarta-taglibs-standard, jakarta-commons-fileupload,
tiles, itest, poi

%package mock
Summary:	Spring mock
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description mock
Spring JNDI mocks, Servlet API mocks

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description manual
%{summary}.

%package demo
Summary:	Samples for %{name}
Group:		Development/Documentation
Requires:	%{name} = 0:%{version}-%{release}
Requires:	antlr
Requires:	axis
Requires:	dom4j
Requires:	jaxen
Requires:	ehcache
Requires:	hsqldb

%description demo
%{summary}.
Optionals: antlr, axis, dom4j, jaxen, ehcache, hsqldb

%prep
%setup -q -n %{name}-framework-%{version}
chmod -R go=u-w *
#find . -name "*.jar" -exec rm {} \;
for f in $(find . -name "*.jar"); do
    mv $f $f.no
done

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav

%build

mkdir -p lib
pushd lib

mkdir -p antlr
pushd antlr
ln -sf $(build-classpath antlr) .
popd

mkdir -p aopalliance
pushd aopalliance
ln -sf $(build-classpath aopalliance) .
popd

mkdir -p axis
pushd axis
ln -sf $(build-classpath axis/axis) .
ln -sf $(build-classpath axis/saaj) .
ln -sf $(build-classpath wsdl4j) .
popd

mkdir -p c3p0
pushd c3p0
ln -sf $(build-classpath c3p0) .
popd

mkdir -p caucho
pushd caucho
ln -sf $(build-classpath burlap) burlap-2.1.12.jar
ln -sf $(build-classpath hessian) hessian-2.1.12.jar
popd

mkdir -p cglib
pushd cglib
ln -sf $(build-classpath cglib) cglib-nodep-2.1_2.jar
ln -sf $(build-classpath asm/asm) .
popd

mkdir -p cos
pushd cos
ln -sf $(build-classpath cos-multipart) cos.jar
popd

mkdir -p dom4j
pushd dom4j
ln -sf $(build-classpath dom4j) .
ln -sf $(build-classpath jaxen) .
popd

mkdir -p easymock
pushd easymock
ln -sf $(build-classpath easymock) .
ln -sf $(build-classpath easymockclassextension) .
popd

mkdir -p ehcache
pushd ehcache
ln -sf $(build-classpath ehcache) ehcache-1.1.jar
popd

mkdir -p freemarker
pushd freemarker
ln -sf $(build-classpath freemarker) .
popd

mkdir -p hibernate
pushd hibernate
ln -sf $(build-classpath hibernate3) hibernate3.jar
ln -sf $(build-classpath hibernate) hibernate2.jar
ln -sf $(build-classpath hibernate-annotations) hibernate-annotations.jar
popd

mkdir -p hsqldb
pushd hsqldb
ln -sf $(build-classpath hsqldb) .
popd

mkdir -p ibatis
pushd ibatis
ln -sf $(build-classpath ibatis1-common) ibatis-common.jar
ln -sf $(build-classpath ibatis1-sqlmap) ibatis-sqlmap.jar
ln -sf $(build-classpath ibatis-sqlmap) ibatis-sqlmap-2.jar
popd

mkdir -p itext
pushd itext
ln -sf $(build-classpath itext) itext-1.3.jar
popd
# BUILD/spring-framework-1.2.4/lib/j2ee/rowset.jar.no
mkdir -p j2ee
pushd j2ee
ln -sf $(build-classpath jaf) activation.jar
ln -sf $(build-classpath j2ee-connector) connector.jar
ln -sf $(build-classpath ejb) .
ln -sf $(build-classpath axis/jaxrpc) .
ln -sf $(build-classpath jdbc-stdext) .
ln -sf $(build-classpath jms) .
ln -sf $(build-classpath jspapi) jspapi.jar
ln -sf $(build-classpath taglibs-core) jstl-core.jar
ln -sf $(build-classpath taglibs-standard) jstl.jar
ln -sf $(build-classpath jta) .
ln -sf $(build-classpath javamail/mailapi) mail.jar
ln -sf $(build-classpath servletapi5) servlet-api.jar
ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
popd
mkdir -p endorsed
pushd endorsed
ln -sf $(build-classpath xerces-j2) xerces.jar
ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
popd

mkdir -p jakarta-commons
pushd jakarta-commons
ln -sf $(build-classpath commons-attributes-api) .
ln -sf $(build-classpath commons-attributes-compiler) .
ln -sf $(build-classpath commons-beanutils) .
ln -sf $(build-classpath commons-codec) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-dbcp) .
ln -sf $(build-classpath commons-digester) .
ln -sf $(build-classpath commons-discovery) .
ln -sf $(build-classpath commons-fileupload) .
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-lang) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath commons-pool) .
ln -sf $(build-classpath commons-validator) .
popd

mkdir -p jakarta-taglibs
pushd jakarta-taglibs
ln -sf $(build-classpath taglibs-standard) standard.jar
popd

mkdir -p jamon
pushd jamon
ln -sf $(build-classpath jamonapi) JAMon.jar
popd

mkdir -p jasperreports
pushd jasperreports
ln -sf $(build-classpath jasperreports) jasperreports-1.0.2.jar
popd

mkdir -p jboss
pushd jboss
ln -sf $(build-classpath jboss4/jboss-common-jdbc-wrapper) .
popd

mkdir -p jdo
pushd jdo
ln -sf $(build-classpath apache-jdo20/jdo2-api) jdo2.jar
popd

mkdir -p jexcelapi
pushd jexcelapi
ln -sf $(build-classpath jexcelapi) jxl.jar
popd

mkdir -p jmx
pushd jmx
ln -sf $(build-classpath jmxri) .
ln -sf $(build-classpath jmxremoteri) .
ln -sf $(build-classpath jmxremoteri-optional) .
popd

mkdir -p jotm
pushd jotm
ln -sf $(build-classpath jotm/jotm) .
ln -sf $(build-classpath xapool) .
popd

mkdir -p jsf
pushd jsf
ln -sf $(build-classpath jsf-api) .
popd

mkdir -p log4j
pushd log4j
ln -sf $(build-classpath log4j) log4j-1.2.9.jar
popd

mkdir -p ojb
pushd ojb
ln -sf $(build-classpath db-ojb/db-ojb) db-ojb-1.0.3.jar
popd

mkdir -p oro
pushd oro
ln -sf $(build-classpath oro) jakarta-oro-2.0.8.jar
popd

mkdir -p poi
pushd poi
ln -sf $(build-classpath poi) poi-2.5.1.jar
popd

mkdir -p quartz
pushd quartz
ln -sf $(build-classpath quartz) .
popd

mkdir -p struts
pushd struts
ln -sf $(build-classpath struts) struts.jar
popd

mkdir -p toplink
pushd toplink
#ln -sf $(build-classpath toplink-api) .
mv toplink-api.jar.no toplink-api.jar
popd

mkdir -p velocity
pushd velocity
ln -sf $(build-classpath velocity-tools-generic) velocity-tools-generic-1.1.jar
ln -sf $(build-classpath velocity-tools-view) velocity-tools-view-1.1.jar
ln -sf $(build-classpath velocity) velocity-1.4.jar
popd

mkdir -p xdoclet
pushd xdoclet
ln -sf $(build-classpath xjavadoc) xjavadoc-1.1.jar
popd
popd

export JAVA_HOME=/usr/lib/jvm/java-1.5.0
export OPT_JAR_LIST="ant/ant-junit junit xjavadoc commons-collections commons-attribute-compiler"

ant -Djava.endorsed.dir=lib/endorsed alljars tests

%install

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 dist/%{name}-aop.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/aop-%{version}.jar
install -m 644 dist/%{name}-beans.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/beans-%{version}.jar
install -m 644 dist/%{name}-context.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/context-%{version}.jar
install -m 644 dist/%{name}-core.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 dist/%{name}-dao.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/dao-%{version}.jar
install -m 644 dist/%{name}-hibernate.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/hibernate-%{version}.jar
install -m 644 dist/%{name}-jdbc.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/jdbc-%{version}.jar
install -m 644 dist/%{name}-mock.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/mock-%{version}.jar
install -m 644 dist/%{name}-orm.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/orm-%{version}.jar
install -m 644 dist/%{name}-remoting.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/remoting-%{version}.jar
install -m 644 dist/%{name}-support.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/support-%{version}.jar
install -m 644 dist/%{name}-web.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/web-%{version}.jar
install -m 644 dist/%{name}-webmvc.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/webmvc-%{version}.jar
install -m 644 dist/%{name}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# definitions
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
install -m 644 dist/%{name}-beans.dtd \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}-beans.dtd
install -m 644 dist/%{name}.ftl \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}.ftl
install -m 644 dist/%{name}.tld \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}.tld
install -m 644 dist/%{name}.vm \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}.vm

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf docs/api

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p license.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/samples
cp -pr samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/samples


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%dir %{_datadir}/%{name}-%{version}
%dir %{_datadir}/%{name}-%{version}/etc
%{_datadir}/%{name}-%{version}/etc/*
%{_docdir}/%{name}-%{version}/license.txt


%files core
%defattr(-,root,root)
%{_javadir}/%{name}/core*.jar

%files aop
%defattr(-,root,root)
%{_javadir}/%{name}/aop*.jar

%files beans
%defattr(-,root,root)
%{_javadir}/%{name}/beans*.jar

%files context
%defattr(-,root,root)
%{_javadir}/%{name}/context*.jar

%files dao
%defattr(-,root,root)
%{_javadir}/%{name}/dao*.jar

%files hibernate
%defattr(-,root,root)
%{_javadir}/%{name}/hibernate*.jar

%files jdbc
%defattr(-,root,root)
%{_javadir}/%{name}/jdbc*.jar

%files orm
%defattr(-,root,root)
%{_javadir}/%{name}/orm*.jar

%files remoting
%defattr(-,root,root)
%{_javadir}/%{name}/remoting*.jar

%files support
%defattr(-,root,root)
%{_javadir}/%{name}/support*.jar

%files web
%defattr(-,root,root)
%{_javadir}/%{name}/web-*.jar
%{_javadir}/%{name}/web.jar

%files webmvc
%defattr(-,root,root)
%{_javadir}/%{name}/webmvc*.jar

%files all
%defattr(-,root,root)
%{_javadir}/%{name}*.jar

%files mock
%defattr(-,root,root)
%{_javadir}/%{name}/mock*.jar

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root)
%{_docdir}/%{name}-%{version}

%files demo
%defattr(-,root,root)
%{_datadir}/%{name}-%{version}/samples

%changelog
* Tue Oct 18 2005 Ralph Apel <r.apel at r-apel.de> 0:1.2.5-2jpp
- Add missing jars and sub-packages

* Thu Sep 29 2005 Ralph Apel <r.apel at r-apel.de> 0:1.2.5-1jpp
- Upgrade to 1.2.5

* Wed Sep 21 2005 Ralph Apel <r.apel at r-apel.de> 0:1.2.4-1jpp
- Upgrade to 1.2.4
- Pending toplink-api from upstream (oracle)
- Pending rowset from upstream (sun), must still build with JDK-1.5

* Fri Mar 11 2005 Ralph Apel <r.apel at r-apel.de> 0:1.1.4-2jpp
- Adapt to axis-1.2: JaxRpcSupportTests.java to override loadService()

* Wed Feb 16 2005 Ralph Apel <r.apel at r-apel.de> 0:1.1.4-1jpp
- Upgrade to 1.1.4 (thx Joe Wortmann)

* Mon Dec 13 2004 Ralph Apel <r.apel at r-apel.de> 0:1.1.3-1jpp
- Upgrade to 1.1.3
- Break up into subpackages and relax dependencies
- Fix non-versioned jars in /usr/share/java/spring

* Fri Oct 08 2004 Ralph Apel <r.apel at r-apel.de> 0:1.1-1jpp
- First release

